using System;

namespace Example
{
    //! The outer class
    public class MainClass
    {
	//! A private inner class
	private class PrivateInner {
            //! A public field inside the class.
            public object Field;
        }

	//! An internal inner class
	internal class InternalInner {
            //! A public field inside the class.
            public object Field;
        }

	//! A protected inner class
	protected class ProtectedInner {
            //! A public field inside the class.
            public object Field;
        }

	//! A public inner class
	public class PublicInner {
            //! A public field inside the class.
            public object Field;
        }

	// ------------------------------

	//! A private method
	private void PrivateMethod() {}

	//! An internal method
	internal void InternalMethod() {}

	//! A protected method
	protected void ProtectedMethod() {}

	//! A public method
	public void PublicMethod() {}

	// ------------------------------

	//! A private property
	private object PrivateProperty { get { return null; } }

	//! An internal property
	internal object InternalProperty { get { return null; } }

	//! A protected property
	protected object ProtectedProperty { get { return null; } }

	//! A public property
	public object PublicProperty { get { return null; } }

    }
}
